diff -ruN tarsnap-autoconf-1.0.32/tar/storage/storage_read.c tarsnap-autoconf-1.0.33/tar/storage/storage_read.c
--- tarsnap-autoconf-1.0.32/tar/storage/storage_read.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/storage/storage_read.c	2012-08-10 00:05:23.000000000 -0700
@@ -1,5 +1,6 @@
 #include "bsdtar_platform.h"
 
+#include <assert.h>
 #include <stdint.h>
 #include <stdlib.h>
 #include <string.h>
@@ -7,6 +8,7 @@
 #include "crypto.h"
 #include "netpacket.h"
 #include "netproto.h"
+#include "rwhashtab.h"
 #include "storage_internal.h"
 #include "sysendian.h"
 #include "warnp.h"
@@ -15,9 +17,23 @@
 
 struct storage_read_internal {
 	NETPACKET_CONNECTION * NPC;
+	RWHASHTAB * cache;
+	struct read_file_cached * cache_mru;	/* Most recently used. */
+	struct read_file_cached * cache_lru;	/* LRU of !evicted files. */
+	size_t cachesz;
+	size_t cachemaxsz;
 	uint64_t machinenum;
 };
 
+struct read_file_cached {
+	uint8_t classname[33];
+	uint8_t * buf;				/* NULL if !inqueue. */
+	size_t buflen;
+	struct read_file_cached * next_lru;	/* Less recently used. */
+	struct read_file_cached * next_mru;	/* More recently used. */
+	int inqueue;
+};
+
 struct read_file_internal {
 	int done;
 	int status;
@@ -28,6 +44,7 @@
 struct read_file_cookie {
 	int (*callback)(void *, int, uint8_t *, size_t);
 	void * cookie;
+	struct storage_read_internal * S;
 	uint64_t machinenum;
 	uint8_t class;
 	uint8_t name[32];
@@ -41,6 +58,95 @@
 static int callback_read_file(void *, int, uint8_t *, size_t);
 
 /**
+ * cache_lru_remove(S, CF):
+ * Remove ${CF} from its current position in the LRU queue for ${S}.
+ */
+static void
+cache_lru_remove(STORAGE_R * S, struct read_file_cached * CF)
+{
+
+	/* Sanity check: We should be in the queue. */
+	assert(CF->inqueue);
+
+	/* Our LRU file is now someone else's LRU file. */
+	if (CF->next_mru != NULL)
+		CF->next_mru->next_lru = CF->next_lru;
+	else
+		S->cache_mru = CF->next_lru;
+
+	/* Our MRU file is now someone else's MRU file. */
+	if (CF->next_lru != NULL)
+		CF->next_lru->next_mru = CF->next_mru;
+	else
+		S->cache_lru = CF->next_mru;
+
+	/* We're no longer in the queue. */
+	CF->inqueue = 0;
+	S->cachesz -= CF->buflen;
+
+	/* We no longer have an MRU or LRU file. */
+	CF->next_mru = NULL;
+	CF->next_lru = NULL;
+}
+
+/**
+ * cache_lru_add(S, CF):
+ * Record ${CF} as the most recently used cached file in ${S}.
+ */
+static void
+cache_lru_add(STORAGE_R * S, struct read_file_cached * CF)
+{
+
+	/* Sanity check: We should not be in the queue yet. */
+	assert(CF->inqueue == 0);
+
+	/* Nobody is more recently used than us... */
+	CF->next_mru = NULL;
+
+	/* ... the formerly MRU file is less recently used than us... */
+	CF->next_lru = S->cache_mru;
+
+	/* ... we're more recently used than any formerly MRU file... */
+	if (CF->next_lru != NULL)
+		CF->next_lru->next_mru = CF;
+
+	/* ... and more recently used than nothing... */
+	if (S->cache_lru == NULL)
+		S->cache_lru = CF;
+
+	/* ... and we're now the MRU file. */
+	S->cache_mru = CF;
+
+	/* We're now in the queue. */
+	CF->inqueue = 1;
+	S->cachesz += CF->buflen;
+}
+
+/**
+ * cache_prune(S):
+ * Prune the cache for ${S} down to size.
+ */
+static void
+cache_prune(STORAGE_R * S)
+{
+	struct read_file_cached * CF;
+
+	/* While the cache is too big... */
+	while (S->cachesz > S->cachemaxsz) {
+		/* Find the LRU cached file. */
+		CF = S->cache_lru;
+
+		/* Remove this file from the LRU list. */
+		cache_lru_remove(S, CF);
+
+		/* Free its data. */
+		free(CF->buf);
+		CF->buf = NULL;
+		CF->buflen = 0;
+	}
+}
+
+/**
  * storage_read_init(machinenum):
  * Prepare for read operations.  Note that since reads are non-transactional,
  * this could be a no-op aside from storing the machine number.
@@ -54,9 +160,20 @@
 	if ((S = malloc(sizeof(struct storage_read_internal))) == NULL)
 		goto err0;
 
+	/* Create a hash table for cached blocks. */
+	if ((S->cache = rwhashtab_init(offsetof(struct read_file_cached,
+	    classname), 33)) == NULL)
+		goto err1;
+
+	/* No cached data yet. */
+	S->cache_lru = NULL;
+	S->cache_mru = NULL;
+	S->cachesz = 0;
+	S->cachemaxsz = (size_t)(-1);
+
 	/* Open netpacket connection. */
 	if ((S->NPC = netpacket_open(USERAGENT)) == NULL)
-		goto err1;
+		goto err2;
 
 	/* Store machine number. */
 	S->machinenum = machinenum;
@@ -64,6 +181,8 @@
 	/* Success! */
 	return (S);
 
+err2:
+	rwhashtab_free(S->cache);
 err1:
 	free(S);
 err0:
@@ -72,6 +191,97 @@
 }
 
 /**
+ * storage_read_cache(S, class, name):
+ * Add the file ${name} from class ${class} into the cache for the read cookie
+ * ${S} returned from storage_read_init.  The data will not be fetched yet;
+ * but any future fetch will look in the cache first and will store the block
+ * in the cache if it needs to be fetched.
+ */
+int
+storage_read_cache(STORAGE_R * S, char class, const uint8_t name[32])
+{
+	uint8_t classname[33];
+	struct read_file_cached * CF;
+
+	/* Prune the cache if necessary. */
+	cache_prune(S);
+
+	/* Is this file already marked as needing to be cached? */
+	classname[0] = class;
+	memcpy(&classname[1], name, 32);
+	if ((CF = rwhashtab_read(S->cache, classname)) != NULL) {
+		/* If we're in the linked list, remove ourselves from it. */
+		if (CF->inqueue)
+			cache_lru_remove(S, CF);
+
+		/* Insert ourselves at the head of the list. */
+		cache_lru_add(S, CF);
+
+		/* That's all we need to do. */
+		goto done;
+	}
+
+	/* Allocate a structure. */
+	if ((CF = malloc(sizeof(struct read_file_cached))) == NULL)
+		goto err0;
+	memcpy(CF->classname, classname, 33);
+	CF->buf = NULL;
+	CF->buflen = 0;
+	CF->inqueue = 0;
+
+	/* Add it to the cache. */
+	if (rwhashtab_insert(S->cache, CF))
+		goto err1;
+
+	/* Add it to the LRU queue. */
+	cache_lru_add(S, CF);
+
+done:
+	/* Success! */
+	return (0);
+
+err1:
+	free(CF);
+err0:
+	/* Failure! */
+	return (-1);
+}
+
+/**
+ * storage_read_cache_limit(S, size):
+ * Set a limit of ${size} bytes on the cache associated with read cookie {S}.
+ */
+void
+storage_read_cache_limit(STORAGE_R * S, size_t size)
+{
+
+	/* Record the new size limit. */
+	S->cachemaxsz = size;
+}
+
+/* Look for a file in the cache. */
+static void
+storage_read_cache_find(STORAGE_R * S, char class, const uint8_t name[32],
+    uint8_t ** buf, size_t * buflen)
+{
+	uint8_t classname[33];
+	struct read_file_cached * CF;
+
+	/* Haven't found it yet. */
+	*buf = NULL;
+	*buflen = 0;
+
+	/* Search for a cache entry. */
+	classname[0] = class;
+	memcpy(&classname[1], name, 32);
+	if ((CF = rwhashtab_read(S->cache, classname)) != NULL) {
+		/* Found it! */
+		*buf = CF->buf;
+		*buflen = CF->buflen;
+	}
+}
+
+/**
  * storage_read_file(S, buf, buflen, class, name):
  * Read the file ${name} from class ${class} using the read cookie ${S}
  * returned from storage_read_init into the buffer ${buf} of length ${buflen}.
@@ -83,6 +293,23 @@
     char class, const uint8_t name[32])
 {
 	struct read_file_internal C;
+	uint8_t * cached_buf;
+	size_t cached_buflen;
+
+	/* Can we serve this from our cache? */
+	storage_read_cache_find(S, class, name, &cached_buf, &cached_buflen);
+	if (cached_buf != NULL) {
+		if (buflen != cached_buflen) {
+			/* Bad length. */
+			C.status = 2;
+			goto done;
+		} else {
+			/* Good length, copy data out. */
+			C.status = 0;
+			memcpy(buf, cached_buf, buflen);
+			goto done;
+		}
+	}
 
 	/* Initialize structure. */
 	C.buf = buf;
@@ -96,6 +323,7 @@
 	if (network_spin(&C.done))
 		goto err0;
 
+done:
 	/* Return status code from server. */
 	return (C.status);
 
@@ -115,6 +343,22 @@
     size_t * buflen, char class, const uint8_t name[32])
 {
 	struct read_file_internal C;
+	uint8_t * cached_buf;
+	size_t cached_buflen;
+
+	/* Can we serve this from our cache? */
+	storage_read_cache_find(S, class, name, &cached_buf, &cached_buflen);
+	if (cached_buf != NULL) {
+		/* Allocate a buffer and copy data out. */
+		if ((*buf = malloc(cached_buflen)) == NULL)
+			goto err0;
+		memcpy(*buf, cached_buf, cached_buflen);
+		*buflen = cached_buflen;
+
+		/* Data is good. */
+		C.status = 0;
+		goto done;
+	}
 
 	/* Initialize structure. */
 	C.buf = NULL;
@@ -134,6 +378,7 @@
 		*buflen = C.buflen;
 	}
 
+done:
 	/* Return status code. */
 	return (C.status);
 
@@ -170,6 +415,7 @@
 		goto err0;
 	C->callback = callback;
 	C->cookie = cookie;
+	C->S = S;
 	C->machinenum = S->machinenum;
 	C->class = class;
 	memcpy(C->name, name, 32);
@@ -215,6 +461,8 @@
     size_t packetlen)
 {
 	struct read_file_cookie * C = cookie;
+	struct read_file_cached * CF;
+	uint8_t classname[33];
 	uint32_t filelen;
 	int sc;
 	int rc;
@@ -296,6 +544,22 @@
 				free(C->buf);
 			goto err0;
 		}
+
+		/* Should we cache this data? */
+		classname[0] = C->class;
+		memcpy(&classname[1], C->name, 32);
+		if (((CF = rwhashtab_read(C->S->cache, classname)) != NULL) &&
+		    (CF->inqueue != 0) && (CF->buf == NULL)) {
+			/* Make a copy of this buffer if we can. */
+			if ((CF->buf = malloc(C->buflen)) != NULL) {
+				/* Copy in data and data length. */
+				CF->buflen = C->buflen;
+				memcpy(CF->buf, C->buf, C->buflen);
+
+				/* We've got more data cached now. */
+				C->S->cachesz += CF->buflen;
+			}
+		}
 	}
 
 	/*
@@ -343,6 +607,22 @@
 	return (0);
 }
 
+/* Free a cache entry. */
+static int
+callback_cache_free(void * record, void * cookie)
+{
+	struct read_file_cached * CF = record;
+
+	(void)cookie; /* UNUSED */
+
+	/* Free the buffer and the structure. */
+	free(CF->buf);
+	free(CF);
+
+	/* Success! */
+	return (0);
+}
+
 /**
  * storage_read_free(S):
  * Close the read cookie ${S} and free any allocated memory.
@@ -354,6 +634,12 @@
 	/* Close netpacket connection. */
 	netpacket_close(S->NPC);
 
+	/* Free contents of cache. */
+	rwhashtab_foreach(S->cache, callback_cache_free, NULL);
+
+	/* Free cache. */
+	rwhashtab_free(S->cache);
+
 	/* Free memory. */
 	free(S);
 }
diff -ruN tarsnap-autoconf-1.0.32/tar/write.c tarsnap-autoconf-1.0.33/tar/write.c
--- tarsnap-autoconf-1.0.32/tar/write.c	2012-02-22 04:10:53.000000000 -0800
+++ tarsnap-autoconf-1.0.33/tar/write.c	2012-08-10 00:05:23.000000000 -0700
@@ -764,6 +764,9 @@
 			break;
 		}
 
+		if (bsdtar->option_no_subdirs)
+			descend = 0;
+
 		/*
 		 * If the user did not specify --insane-filesystems, do not
 		 * cross into a new filesystem which is known to be synthetic.
@@ -810,8 +813,15 @@
 		 * In -u mode, check that the file is newer than what's
 		 * already in the archive; in all modes, obey --newerXXX flags.
 		 */
-		if (!new_enough(bsdtar, name, st))
+		if (!new_enough(bsdtar, name, st)) {
+			if (!descend)
+				continue;
+			if (bsdtar->option_interactive &&
+			    !yes("add '%s'", name))
+				continue;
+			tree_descend(tree);
 			continue;
+		}
 
 		archive_entry_free(entry);
 		entry = archive_entry_new();
@@ -885,7 +895,7 @@
 			continue;
 
 		/* Note: if user vetoes, we won't descend. */
-		if (descend && !bsdtar->option_no_subdirs)
+		if (descend)
 			tree_descend(tree);
 
 		/*
